package klassen;

import java.awt.Color;
import java.awt.EventQueue;
import java.awt.Font;

import javax.swing.DefaultComboBoxModel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JTabbedPane;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class Hauptfenster extends JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = -2461459829681481734L;
	private JPanel contentPane;
	private Listenverwaltung dieListen = new Listenverwaltung();
	private JComboBox cbMitarbeiter;
	private JComboBox cbDienstwagen;
	private DefaultComboBoxModel cbmMitarbeiter = new DefaultComboBoxModel();
	private DefaultComboBoxModel cbmDienstwagen 
		= new DefaultComboBoxModel();
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Hauptfenster frame = new Hauptfenster();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public Hauptfenster() {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 557, 515);
		contentPane = new JPanel();
		contentPane.setBackground(Color.WHITE);
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		
		JTabbedPane tpReiter = new JTabbedPane(JTabbedPane.TOP);
		tpReiter.setBounds(10, 72, 521, 394);
		contentPane.add(tpReiter);
		
		JPanel pa_zuordnen = new JPanel();
		tpReiter.addTab("Zuordnen", null, pa_zuordnen, null);
		pa_zuordnen.setLayout(null);
		
		cbMitarbeiter = new JComboBox();
		cbMitarbeiter.setModel(cbmMitarbeiter);
		initialisiereCBMitarbeiter();
		
		cbMitarbeiter.setBounds(10, 49, 200, 31);
		pa_zuordnen.add(cbMitarbeiter);
		
		
		JLabel lbMitarbeiter = new JLabel("Mitarbeiter ausw\u00E4hlen:");
		lbMitarbeiter.setBounds(10, 10, 200, 50);
		pa_zuordnen.add(lbMitarbeiter);
		
		JLabel lbDienstwagen = new JLabel("Dienstwagen ausw\u00E4hlen:");
		lbDienstwagen.setBounds(10, 126, 200, 50);
		pa_zuordnen.add(lbDienstwagen);
		
		cbDienstwagen = new JComboBox();
		cbDienstwagen.setModel(cbmDienstwagen);
		initialisiereCBDienstwagen();
		cbDienstwagen.setBounds(10, 167, 200, 31);
		pa_zuordnen.add(cbDienstwagen);
		
		JButton btSchliessen = new JButton("Schlie\u00DFen");
		btSchliessen.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				System.exit(0);
			}
		});
		btSchliessen.setBounds(202, 280, 143, 23);
		pa_zuordnen.add(btSchliessen);
		
		JButton btZuordnen = new JButton("Zuordnen");
		btZuordnen.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				//Eingabe
				Mitarbeiter mM = (Mitarbeiter) cbmMitarbeiter.getSelectedItem();
				Dienstwagen mD = (Dienstwagen) cbmDienstwagen.getSelectedItem();
				
				//Verarbeitung
				if(mD.istVerfuegbar()){
					dieListen.zuordnen(mM, mD);
					mD.setVerfuegbar(false);
					
					//Ausgabe
					JOptionPane.showMessageDialog(null, mD.toString() + " ist nun belegt!");
				}else{
									
					//Ausgabe
					JOptionPane.showMessageDialog(null, mD.toString() + " ist immer noch belegt!");
				}
								
			}
		});
		btZuordnen.setBounds(10, 280, 155, 23);
		pa_zuordnen.add(btZuordnen);
		
		JPanel pa_mitarbeiter = new JPanel();
		tpReiter.addTab("Mitarbeiter bearbeiten", null, pa_mitarbeiter, null);
		
		JPanel pa_dienstwagen = new JPanel();
		tpReiter.addTab("Dienstwagen bearbeiten", null, pa_dienstwagen, null);
		
		JLabel lbTitel = new JLabel("Dienstwagenverwaltung");
		lbTitel.setFont(new Font("Tahoma", Font.PLAIN, 18));
		lbTitel.setBounds(10, 11, 200, 50);
		contentPane.add(lbTitel);
		
		JLabel lbLogo = new JLabel("");
		lbLogo.setIcon(new ImageIcon(Hauptfenster.class.getResource("/dienstwagen_N_M/logo_final.png")));
		lbLogo.setBounds(363, 11, 178, 50);
		contentPane.add(lbLogo);
	}
	
	private void initialisiereCBMitarbeiter(){
		for(int i=0; i< dieListen.getFahrerliste().size();i++){
			Mitarbeiter m = dieListen.holeMitarbeiter(i);
			cbmMitarbeiter.addElement(m);
		}		
	}
	
	private void initialisiereCBDienstwagen(){
		for(int i=0; i <dieListen.getWagenliste().size();i++){
			Dienstwagen x = dieListen.holeDienstwagen(i);
			cbmDienstwagen.addElement(x);
		}
	}
}
